diff --git a/libr/anal/op.c b/libr/anal/op.c
index 54df59e6158..fe1ed079549 100644
--- a/libr/anal/op.c
+++ b/libr/anal/op.c
@@ -74,7 +74,8 @@ static RAnalVar *get_used_var(RAnal *anal, RAnalOp *op) {
 R_API int r_anal_op(RAnal *anal, RAnalOp *op, ut64 addr, const ut8 *data, int len) {
 	int ret = 0;
 
-	if (!anal) return -1;
+	//len will end up in memcmp so check for negative	
+	if (!anal || len < 0) return -1;
 	if (anal->pcalign) {
 		if (addr % anal->pcalign) {
 			memset (op, 0, sizeof (RAnalOp));
